Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_deallocation.cpp	(revision 43)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_deallocation.cpp	(revision 44)
@@ -21,131 +21,65 @@
     log_printf(FUNC,Meta_Predictor_Glue,"deallocation","Begin");
 
-#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
-    delete in_CLOCK;
-#endif
-
-    // Interface Predict
-    for (uint32_t i=0; i<_param._nb_prediction; i++)
-      {
-	if (_param._have_meta_predictor)
-	{
-	delete  in_PREDICT_PREDICTOR_0_ACK                   [i];
-	delete  in_PREDICT_PREDICTOR_1_ACK                   [i];
-	}
-	delete  in_PREDICT_PREDICTOR_2_ACK                   [i];
-	delete out_PREDICT_ACK                               [i];
-	if (_param._have_meta_predictor)
-	{
-	if (_param._predictor_0_have_bht)
-	delete  in_PREDICT_PREDICTOR_0_BHT_HISTORY           [i];
-	if (_param._predictor_0_have_pht)
-	delete  in_PREDICT_PREDICTOR_0_PHT_HISTORY           [i];
-	if (_param._predictor_1_have_bht)
-	delete  in_PREDICT_PREDICTOR_1_BHT_HISTORY           [i];
-	if (_param._predictor_1_have_pht)
-	delete  in_PREDICT_PREDICTOR_1_PHT_HISTORY           [i];
-	}
-	if (_param._predictor_2_have_bht)
-	delete  in_PREDICT_PREDICTOR_2_BHT_HISTORY           [i];
-	if (_param._predictor_2_have_pht)
-	delete  in_PREDICT_PREDICTOR_2_PHT_HISTORY           [i];
-	delete out_PREDICT_HISTORY                           [i];
-	delete out_PREDICT_DIRECTION                         [i];
-      }
+    delete     in_CLOCK;
+    delete     in_NRESET;
 
     if (_param._have_meta_predictor)
     {
-    delete  in_PREDICT_PREDICTOR_0_ACK;
-    delete  in_PREDICT_PREDICTOR_1_ACK;
+    delete []   in_PREDICT_PREDICTOR_0_ACK;
+    delete []   in_PREDICT_PREDICTOR_1_ACK;
     }			           
-    delete  in_PREDICT_PREDICTOR_2_ACK;
-    delete out_PREDICT_ACK            ;
+    delete []   in_PREDICT_PREDICTOR_2_ACK;
+    delete []  out_PREDICT_ACK            ;
     if (_param._have_meta_predictor)
     {
     if (_param._predictor_0_have_bht)
-    delete  in_PREDICT_PREDICTOR_0_BHT_HISTORY;
+    delete []   in_PREDICT_PREDICTOR_0_BHT_HISTORY;
     if (_param._predictor_0_have_pht)
-    delete  in_PREDICT_PREDICTOR_0_PHT_HISTORY;
+    delete []   in_PREDICT_PREDICTOR_0_PHT_HISTORY;
     if (_param._predictor_1_have_bht)
-    delete  in_PREDICT_PREDICTOR_1_BHT_HISTORY;
+    delete []   in_PREDICT_PREDICTOR_1_BHT_HISTORY;
     if (_param._predictor_1_have_pht)
-    delete  in_PREDICT_PREDICTOR_1_PHT_HISTORY ;
+    delete []   in_PREDICT_PREDICTOR_1_PHT_HISTORY ;
     }
     if (_param._predictor_2_have_bht)
-    delete  in_PREDICT_PREDICTOR_2_BHT_HISTORY ;
+    delete []   in_PREDICT_PREDICTOR_2_BHT_HISTORY ;
     if (_param._predictor_2_have_pht)
-    delete  in_PREDICT_PREDICTOR_2_PHT_HISTORY ;
-    delete out_PREDICT_HISTORY                 ;
-    delete out_PREDICT_DIRECTION               ;
-
-    // Interface Branch_complete
-    for (uint32_t i=0; i<_param._nb_branch_complete; i++)
-      {
-	if (_param._have_meta_predictor)
-	{
-	delete  in_BRANCH_COMPLETE_VAL                               [i];
-	delete out_BRANCH_COMPLETE_PREDICTOR_2_VAL                   [i];
-
-	delete  in_BRANCH_COMPLETE_PREDICTOR_0_ACK                   [i];
-	delete  in_BRANCH_COMPLETE_PREDICTOR_1_ACK                   [i];
-	}
-	delete  in_BRANCH_COMPLETE_PREDICTOR_2_ACK                   [i];
-	delete out_BRANCH_COMPLETE_ACK                               [i];
- 
-	if (_param._have_meta_predictor)
-	{
-	if (_param._predictor_0_have_bht)
-	delete out_BRANCH_COMPLETE_PREDICTOR_0_BHT_HISTORY           [i];
-	if (_param._predictor_0_have_pht)
-	delete out_BRANCH_COMPLETE_PREDICTOR_0_PHT_HISTORY           [i];
-	if (_param._predictor_1_have_bht)
-	delete out_BRANCH_COMPLETE_PREDICTOR_1_BHT_HISTORY           [i];
-	if (_param._predictor_1_have_pht)
-	delete out_BRANCH_COMPLETE_PREDICTOR_1_PHT_HISTORY           [i];
-	}
-	if (_param._predictor_2_have_bht)
-	delete out_BRANCH_COMPLETE_PREDICTOR_2_BHT_HISTORY           [i];
-	if (_param._predictor_2_have_pht)
-	delete out_BRANCH_COMPLETE_PREDICTOR_2_PHT_HISTORY           [i];
-	delete  in_BRANCH_COMPLETE_HISTORY                           [i];
-	if (_param._have_meta_predictor)
-	  {
-	delete  in_BRANCH_COMPLETE_DIRECTION                         [i];
-	delete out_BRANCH_COMPLETE_PREDICTOR_2_DIRECTION             [i];
-	  }
-      }
+    delete []   in_PREDICT_PREDICTOR_2_PHT_HISTORY ;
+    delete []  out_PREDICT_HISTORY                 ;
+    delete []  out_PREDICT_DIRECTION               ;
 
     if (_param._have_meta_predictor)
     {
-    delete  in_BRANCH_COMPLETE_VAL                     ;
-    delete out_BRANCH_COMPLETE_PREDICTOR_2_VAL         ;
+    delete []   in_BRANCH_COMPLETE_VAL                     ;
+    delete []  out_BRANCH_COMPLETE_PREDICTOR_2_VAL         ;
 
-    delete  in_BRANCH_COMPLETE_PREDICTOR_0_ACK         ;
-    delete  in_BRANCH_COMPLETE_PREDICTOR_1_ACK         ;
+    delete []   in_BRANCH_COMPLETE_PREDICTOR_0_ACK         ;
+    delete []   in_BRANCH_COMPLETE_PREDICTOR_1_ACK         ;
     }			           
-    delete  in_BRANCH_COMPLETE_PREDICTOR_2_ACK         ;
-    delete out_BRANCH_COMPLETE_ACK                     ;
+    delete []   in_BRANCH_COMPLETE_PREDICTOR_2_ACK         ;
+    delete []  out_BRANCH_COMPLETE_ACK                     ;
     if (_param._have_meta_predictor)
     {
     if (_param._predictor_0_have_bht)
-    delete out_BRANCH_COMPLETE_PREDICTOR_0_BHT_HISTORY ;
+    delete []  out_BRANCH_COMPLETE_PREDICTOR_0_BHT_HISTORY ;
     if (_param._predictor_0_have_pht)
-    delete out_BRANCH_COMPLETE_PREDICTOR_0_PHT_HISTORY ;
+    delete []  out_BRANCH_COMPLETE_PREDICTOR_0_PHT_HISTORY ;
     if (_param._predictor_1_have_bht)
-    delete out_BRANCH_COMPLETE_PREDICTOR_1_BHT_HISTORY ;
+    delete []  out_BRANCH_COMPLETE_PREDICTOR_1_BHT_HISTORY ;
     if (_param._predictor_1_have_pht)
-    delete out_BRANCH_COMPLETE_PREDICTOR_1_PHT_HISTORY ;
+    delete []  out_BRANCH_COMPLETE_PREDICTOR_1_PHT_HISTORY ;
     }
     if (_param._predictor_2_have_bht)
-    delete out_BRANCH_COMPLETE_PREDICTOR_2_BHT_HISTORY ;
+    delete []  out_BRANCH_COMPLETE_PREDICTOR_2_BHT_HISTORY ;
     if (_param._predictor_2_have_pht)
-    delete out_BRANCH_COMPLETE_PREDICTOR_2_PHT_HISTORY ;
-    delete  in_BRANCH_COMPLETE_HISTORY                 ;
+    delete []  out_BRANCH_COMPLETE_PREDICTOR_2_PHT_HISTORY ;
+    delete []   in_BRANCH_COMPLETE_HISTORY                 ;
     if (_param._have_meta_predictor)
       {
-    delete  in_BRANCH_COMPLETE_DIRECTION               ;
-    delete out_BRANCH_COMPLETE_PREDICTOR_2_DIRECTION   ;
+    delete []   in_BRANCH_COMPLETE_DIRECTION               ;
+    delete []  out_BRANCH_COMPLETE_PREDICTOR_2_DIRECTION   ;
       }
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    delete _component;
 
     log_printf(FUNC,Meta_Predictor_Glue,"deallocation","End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_genMealy_branch_complete_history.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_genMealy_branch_complete_history.cpp	(revision 43)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_genMealy_branch_complete_history.cpp	(revision 44)
@@ -8,5 +8,5 @@
 
 #include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/include/Meta_Predictor_Glue.h"
-#include "Include/BitManipulation.h"
+#include "Common/include/BitManipulation.h"
 
 namespace morpheo                    {
@@ -27,5 +27,5 @@
 	if (_param._have_meta_predictor)
 	  {
-	if (_param._predictor_0_have_bht)
+	if (_param._predictor_0_have_bht) 
 	PORT_WRITE(out_BRANCH_COMPLETE_PREDICTOR_0_BHT_HISTORY [i], (history >> _param._shift_0) & gen_mask<Tbht_history_t>(_param._predictor_0_bht_size_shifter));
 	if (_param._predictor_0_have_pht)
@@ -34,10 +34,7 @@
 
 	if (_param._predictor_1_have_bht)
-	  {
 	PORT_WRITE(out_BRANCH_COMPLETE_PREDICTOR_1_BHT_HISTORY [i], (history >> _param._shift_2) & gen_mask<Tbht_history_t>(_param._predictor_1_bht_size_shifter));
-
 	if (_param._predictor_1_have_pht)
 	PORT_WRITE(out_BRANCH_COMPLETE_PREDICTOR_1_PHT_HISTORY [i], (history >> _param._shift_3) & gen_mask<Tpht_history_t>(_param._predictor_1_pht_size_counter));
-	  }
 
 	if (_param._predictor_2_have_bht)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl.cpp	(revision 43)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl.cpp	(revision 44)
@@ -21,13 +21,17 @@
   {
     log_printf(FUNC,Meta_Predictor_Glue,"vhdl","Begin");
-    Vhdl vhdl (_name);
 
-    vhdl.set_library_work (_name + "_Pack");
+    Vhdl * vhdl = new Vhdl (_name);
 
-    vhdl_port        (vhdl);
+    _interfaces->set_port     (vhdl);
+    _component ->vhdl_instance(vhdl);
+
     vhdl_declaration (vhdl);
     vhdl_body        (vhdl);
 
-    vhdl.generate_file();
+    vhdl->generate_file();
+
+    delete vhdl;
+
     log_printf(FUNC,Meta_Predictor_Glue,"vhdl","End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl_body.cpp	(revision 43)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl_body.cpp	(revision 44)
@@ -17,15 +17,15 @@
 
 
-  void Meta_Predictor_Glue::vhdl_body (Vhdl & vhdl)
+  void Meta_Predictor_Glue::vhdl_body (Vhdl * & vhdl)
   {
     log_printf(FUNC,Meta_Predictor_Glue,"vhdl_body","Begin");
-    vhdl.set_body ("");
-    vhdl.set_body (" -- predict");
+    vhdl->set_body ("");
+    vhdl->set_body (" -- predict");
     
     for (uint32_t i=0; i<_param._nb_prediction; i++)
       {
-	string meta_predictor_ack =  (_param._have_meta_predictor==true)?("in_PREDICT_PREDICTOR_0_ACK_"+toString(i)+" and in_PREDICT_PREDICTOR_1_ACK_"+toString(i)):"'1'";
+	string meta_predictor_ack =  (_param._have_meta_predictor==true)?("in_PREDICT_"+toString(i)+"_PREDICTOR_0_ACK and in_PREDICT_"+toString(i)+"_PREDICTOR_1_ACK"):"'1'";
 
-	vhdl.set_body ("out_PREDICT_ACK_"+toString(i)+"         <= "+meta_predictor_ack+" and "+"in_PREDICT_PREDICTOR_2_ACK_"+toString(i)+";");
+	vhdl->set_body ("out_PREDICT_"+toString(i)+"_ACK         <= "+meta_predictor_ack+" and "+"in_PREDICT_"+toString(i)+"_PREDICTOR_2_ACK;");
 
 	uint32_t index=_param._size_history;
@@ -34,10 +34,10 @@
 	if (_param._predictor_2_have_pht)
 	  {
-	vhdl.set_body ("out_PREDICT_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_2_pht_size_counter)+" <= in_PREDICT_PREDICTOR_2_PHT_HISTORY_"+toString(i)+";");
+	vhdl->set_body ("out_PREDICT_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_2_pht_size_counter)+" <= in_PREDICT_"+toString(i)+"_PREDICTOR_2_PHT_HISTORY;");
 	index-= _param._predictor_2_pht_size_counter;
 	  }
 	if (_param._predictor_2_have_bht)
 	  {
-	vhdl.set_body ("out_PREDICT_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_2_bht_size_shifter)+" <= in_PREDICT_PREDICTOR_2_BHT_HISTORY_"+toString(i)+";");
+	vhdl->set_body ("out_PREDICT_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_2_bht_size_shifter)+" <= in_PREDICT_"+toString(i)+"_PREDICTOR_2_BHT_HISTORY;");
 	index-= _param._predictor_2_bht_size_shifter;
 	  }
@@ -47,10 +47,10 @@
 	if (_param._predictor_1_have_pht)
 	  {
-	vhdl.set_body ("out_PREDICT_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_1_pht_size_counter)+" <= in_PREDICT_PREDICTOR_1_PHT_HISTORY_"+toString(i)+";");
+	vhdl->set_body ("out_PREDICT_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_1_pht_size_counter)+" <= in_PREDICT_"+toString(i)+"_PREDICTOR_1_PHT_HISTORY;");
 	index-= _param._predictor_1_pht_size_counter;
 	  }
 	if (_param._predictor_1_have_bht)
 	  {
-	vhdl.set_body ("out_PREDICT_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_1_bht_size_shifter)+" <= in_PREDICT_PREDICTOR_1_BHT_HISTORY_"+toString(i)+";");
+	vhdl->set_body ("out_PREDICT_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_1_bht_size_shifter)+" <= in_PREDICT_"+toString(i)+"_PREDICTOR_1_BHT_HISTORY;");
 	index-= _param._predictor_1_bht_size_shifter;
 	  }
@@ -58,10 +58,10 @@
  	if (_param._predictor_0_have_pht)
 	  {
-	vhdl.set_body ("out_PREDICT_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_0_pht_size_counter)+" <= in_PREDICT_PREDICTOR_0_PHT_HISTORY_"+toString(i)+";");
+	vhdl->set_body ("out_PREDICT_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_0_pht_size_counter)+" <= in_PREDICT_"+toString(i)+"_PREDICTOR_0_PHT_HISTORY;");
 	index-= _param._predictor_0_pht_size_counter;
 	  }
 	if (_param._predictor_0_have_bht)
 	  {
-	vhdl.set_body ("out_PREDICT_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_0_bht_size_shifter)+" <= in_PREDICT_PREDICTOR_0_BHT_HISTORY_"+toString(i)+";");
+	vhdl->set_body ("out_PREDICT_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_0_bht_size_shifter)+" <= in_PREDICT_"+toString(i)+"_PREDICTOR_0_BHT_HISTORY;");
 	index-= _param._predictor_0_bht_size_shifter;
 	  }
@@ -69,15 +69,15 @@
 
 	// direction of prediction
-	vhdl.set_body ("");
+	vhdl->set_body ("");
 	if (_param._have_meta_predictor)
-	  vhdl.set_body ("out_PREDICT_DIRECTION_"+toString(i)+"   <= predict_predictor_0_direction_"+toString(i)+" when predict_predictor_2_direction_"+toString(i)+"='0' else predict_predictor_1_direction_"+toString(i)+";");
+	  vhdl->set_body ("out_PREDICT_"+toString(i)+"_DIRECTION   <= predict_"+toString(i)+"_predictor_0_direction when predict_"+toString(i)+"_predictor_2_direction='0' else predict_"+toString(i)+"_predictor_1_direction;");
 	else
-	  vhdl.set_body ("out_PREDICT_DIRECTION_"+toString(i)+"   <= predict_predictor_2_direction_"+toString(i)+";");
+	  vhdl->set_body ("out_PREDICT_"+toString(i)+"_DIRECTION   <= predict_"+toString(i)+"_predictor_2_direction;");
       }
 
     // Interface - branch_complete
 
-    vhdl.set_body ("");
-    vhdl.set_body (" -- branch_complete");
+    vhdl->set_body ("");
+    vhdl->set_body (" -- branch_complete");
     for (uint32_t i=0; i<_param._nb_branch_complete; i++)
       {
@@ -85,11 +85,11 @@
 	if (_param._have_meta_predictor)
 	  {
-	vhdl.set_body ("out_BRANCH_COMPLETE_PREDICTOR_2_VAL_"+toString(i)+"       <= (branch_complete_predictor_0_direction_"+toString(i)+" xor branch_complete_predictor_1_direction_"+toString(i)+") and "+"in_BRANCH_COMPLETE_VAL_"+toString(i)+";");
-	vhdl.set_body ("out_BRANCH_COMPLETE_PREDICTOR_2_DIRECTION_"+toString(i)+" <= (branch_complete_predictor_0_direction_"+toString(i)+" and not in_BRANCH_COMPLETE_DIRECTION_"+toString(i)+") or (branch_complete_predictor_1_direction_"+toString(i)+" and in_BRANCH_COMPLETE_DIRECTION_"+toString(i)+");");
+	vhdl->set_body ("out_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_2_VAL       <= (branch_complete_"+toString(i)+"_predictor_0_direction xor branch_complete_"+toString(i)+"_predictor_1_direction) and "+"in_BRANCH_COMPLETE_"+toString(i)+"_VAL;");
+	vhdl->set_body ("out_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_2_DIRECTION <= (branch_complete_"+toString(i)+"_predictor_0_direction and not in_BRANCH_COMPLETE_"+toString(i)+"_DIRECTION) or (branch_complete_"+toString(i)+"_predictor_1_direction and in_BRANCH_COMPLETE_"+toString(i)+"_DIRECTION);");
 	  }
 
-	string meta_predictor_ack =  (_param._have_meta_predictor==true)?("in_BRANCH_COMPLETE_PREDICTOR_0_ACK_"+toString(i)+" and in_BRANCH_COMPLETE_PREDICTOR_1_ACK_"+toString(i)):"'1'";
+	string meta_predictor_ack =  (_param._have_meta_predictor==true)?("in_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_0_ACK and in_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_1_ACK"):"'1'";
 
-	vhdl.set_body ("out_BRANCH_COMPLETE_ACK_"+toString(i)+"                   <= "+meta_predictor_ack+" and "+"in_BRANCH_COMPLETE_PREDICTOR_2_ACK_"+toString(i)+";");
+	vhdl->set_body ("out_BRANCH_COMPLETE_"+toString(i)+"_ACK                   <= "+meta_predictor_ack+" and "+"in_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_2_ACK;");
 
 	uint32_t index=_param._size_history;
@@ -97,10 +97,10 @@
 	if (_param._predictor_2_have_pht)
 	  {
-	vhdl.set_body ("out_BRANCH_COMPLETE_PREDICTOR_2_PHT_HISTORY_"+toString(i)+" <= in_BRANCH_COMPLETE_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_2_pht_size_counter)+";");
+	vhdl->set_body ("out_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_2_PHT_HISTORY <= in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_2_pht_size_counter)+";");
 	index-= _param._predictor_2_pht_size_counter;
 	  }
 	if (_param._predictor_2_have_bht)
 	  {
-	vhdl.set_body ("out_BRANCH_COMPLETE_PREDICTOR_2_BHT_HISTORY_"+toString(i)+" <= in_BRANCH_COMPLETE_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_2_bht_size_shifter)+";");
+	vhdl->set_body ("out_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_2_BHT_HISTORY <= in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_2_bht_size_shifter)+";");
 	index-= _param._predictor_2_bht_size_shifter;
 	  }
@@ -110,10 +110,10 @@
 	if (_param._predictor_1_have_pht)
 	  {
-	vhdl.set_body ("out_BRANCH_COMPLETE_PREDICTOR_1_PHT_HISTORY_"+toString(i)+" <= in_BRANCH_COMPLETE_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_1_pht_size_counter)+";");
+	vhdl->set_body ("out_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_1_PHT_HISTORY <= in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_1_pht_size_counter)+";");
 	index-= _param._predictor_1_pht_size_counter;
 	  }
 	if (_param._predictor_1_have_bht)
 	  {
-	vhdl.set_body ("out_BRANCH_COMPLETE_PREDICTOR_1_BHT_HISTORY_"+toString(i)+" <= in_BRANCH_COMPLETE_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_1_bht_size_shifter)+";");
+	vhdl->set_body ("out_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_1_BHT_HISTORY <= in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_1_bht_size_shifter)+";");
 	index-= _param._predictor_1_bht_size_shifter;
 	  }
@@ -121,10 +121,10 @@
 	if (_param._predictor_0_have_pht)
 	  {
-	vhdl.set_body ("out_BRANCH_COMPLETE_PREDICTOR_0_PHT_HISTORY_"+toString(i)+" <= in_BRANCH_COMPLETE_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_0_pht_size_counter)+";");
+	vhdl->set_body ("out_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_0_PHT_HISTORY <= in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_0_pht_size_counter)+";");
 	index-= _param._predictor_0_pht_size_counter;
 	  }
 	if (_param._predictor_0_have_bht)
 	  {
-	vhdl.set_body ("out_BRANCH_COMPLETE_PREDICTOR_0_BHT_HISTORY_"+toString(i)+" <= in_BRANCH_COMPLETE_HISTORY_"+toString(i)+std_logic_range(index-1,index-_param._predictor_0_bht_size_shifter)+";");
+	vhdl->set_body ("out_BRANCH_COMPLETE_"+toString(i)+"_PREDICTOR_0_BHT_HISTORY <= in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY"+std_logic_range(index-1,index-_param._predictor_0_bht_size_shifter)+";");
 	index-= _param._predictor_0_bht_size_shifter;
 	  }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl_declaration.cpp	(revision 43)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl_declaration.cpp	(revision 44)
@@ -17,5 +17,5 @@
 
 
-  void Meta_Predictor_Glue::vhdl_declaration (Vhdl & vhdl)
+  void Meta_Predictor_Glue::vhdl_declaration (Vhdl * & vhdl)
   {
     log_printf(FUNC,Meta_Predictor_Glue,"vhdl_declaration","Begin");
@@ -26,17 +26,17 @@
 	  {
 	if (_param._predictor_0_have_pht)
-	  vhdl.set_alias ("predict_predictor_0_direction_"+toString(i),std_logic(1), "in_PREDICT_PREDICTOR_0_PHT_HISTORY_"+toString(i),std_logic_range(_param._predictor_0_pht_size_counter-1,_param._predictor_0_pht_size_counter-1));
+	  vhdl->set_alias ("predict_"+toString(i)+"_predictor_0_direction",std_logic(1), "in_PREDICT_"+toString(i)+"_PREDICTOR_0_PHT_HISTORY",std_logic_range(_param._predictor_0_pht_size_counter-1,_param._predictor_0_pht_size_counter-1));
 	else
-	  vhdl.set_alias ("predict_predictor_0_direction_"+toString(i),std_logic(1), "in_PREDICT_PREDICTOR_0_BHT_HISTORY_"+toString(i),std_logic_range(_param._predictor_0_bht_size_shifter-1,_param._predictor_0_bht_size_shifter-1));
+	  vhdl->set_alias ("predict_"+toString(i)+"_predictor_0_direction",std_logic(1), "in_PREDICT_"+toString(i)+"_PREDICTOR_0_BHT_HISTORY",std_logic_range(_param._predictor_0_bht_size_shifter-1,_param._predictor_0_bht_size_shifter-1));
 	if (_param._predictor_1_have_pht)
-	  vhdl.set_alias ("predict_predictor_1_direction_"+toString(i),std_logic(1), "in_PREDICT_PREDICTOR_1_PHT_HISTORY_"+toString(i),std_logic_range(_param._predictor_1_pht_size_counter-1,_param._predictor_1_pht_size_counter-1));
+	  vhdl->set_alias ("predict_"+toString(i)+"_predictor_1_direction",std_logic(1), "in_PREDICT_"+toString(i)+"_PREDICTOR_1_PHT_HISTORY",std_logic_range(_param._predictor_1_pht_size_counter-1,_param._predictor_1_pht_size_counter-1));
 	else
-	  vhdl.set_alias ("predict_predictor_1_direction_"+toString(i),std_logic(1), "in_PREDICT_PREDICTOR_1_BHT_HISTORY_"+toString(i),std_logic_range(_param._predictor_1_bht_size_shifter-1,_param._predictor_1_bht_size_shifter-1));
+	  vhdl->set_alias ("predict_"+toString(i)+"_predictor_1_direction",std_logic(1), "in_PREDICT_"+toString(i)+"_PREDICTOR_1_BHT_HISTORY",std_logic_range(_param._predictor_1_bht_size_shifter-1,_param._predictor_1_bht_size_shifter-1));
 	  }
 
 	if (_param._predictor_2_have_pht)
-	  vhdl.set_alias ("predict_predictor_2_direction_"+toString(i),std_logic(1), "in_PREDICT_PREDICTOR_2_PHT_HISTORY_"+toString(i),std_logic_range(_param._predictor_2_pht_size_counter-1,_param._predictor_2_pht_size_counter-1));
+	  vhdl->set_alias ("predict_"+toString(i)+"_predictor_2_direction",std_logic(1), "in_PREDICT_"+toString(i)+"_PREDICTOR_2_PHT_HISTORY",std_logic_range(_param._predictor_2_pht_size_counter-1,_param._predictor_2_pht_size_counter-1));
 	else
-	  vhdl.set_alias ("predict_predictor_2_direction_"+toString(i),std_logic(1), "in_PREDICT_PREDICTOR_2_BHT_HISTORY_"+toString(i),std_logic_range(_param._predictor_2_bht_size_shifter-1,_param._predictor_2_bht_size_shifter-1));
+	  vhdl->set_alias ("predict_"+toString(i)+"_predictor_2_direction",std_logic(1), "in_PREDICT_"+toString(i)+"_PREDICTOR_2_BHT_HISTORY",std_logic_range(_param._predictor_2_bht_size_shifter-1,_param._predictor_2_bht_size_shifter-1));
       }
 
@@ -46,22 +46,20 @@
       {
 // 	if (_param._predictor_2_have_pht)
-// 	vhdl.set_alias ("branch_complete_predictor_2_direction_"+toString(i),std_logic(1)," in_BRANCH_COMPLETE_HISTORY_"+toString(i),std_logic_range(_param._shift_6-1, _param._shift_6-1));
+// 	vhdl->set_alias ("branch_complete_"+toString(i)+"_predictor_2_direction",std_logic(1)," in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY",std_logic_range(_param._shift_6-1, _param._shift_6-1));
 // 	else
-// 	vhdl.set_alias ("branch_complete_predictor_2_direction_"+toString(i),std_logic(1)," in_BRANCH_COMPLETE_HISTORY_"+toString(i),std_logic_range(_param._shift_5-1, _param._shift_5-1));
+// 	vhdl->set_alias ("branch_complete_"+toString(i)+"_predictor_2_direction",std_logic(1)," in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY",std_logic_range(_param._shift_5-1, _param._shift_5-1));
 
 	if (_param._predictor_1_have_pht)
-	vhdl.set_alias ("branch_complete_predictor_1_direction_"+toString(i),std_logic(1)," in_BRANCH_COMPLETE_HISTORY_"+toString(i),std_logic_range(_param._shift_4-1, _param._shift_4-1));
+	vhdl->set_alias ("branch_complete_"+toString(i)+"_predictor_1_direction",std_logic(1)," in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY",std_logic_range(_param._shift_4-1, _param._shift_4-1));
 	else
-	vhdl.set_alias ("branch_complete_predictor_1_direction_"+toString(i),std_logic(1)," in_BRANCH_COMPLETE_HISTORY_"+toString(i),std_logic_range(_param._shift_3-1, _param._shift_3-1));
+	vhdl->set_alias ("branch_complete_"+toString(i)+"_predictor_1_direction",std_logic(1)," in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY",std_logic_range(_param._shift_3-1, _param._shift_3-1));
 
 	if (_param._predictor_0_have_pht)
-	vhdl.set_alias ("branch_complete_predictor_0_direction_"+toString(i),std_logic(1)," in_BRANCH_COMPLETE_HISTORY_"+toString(i),std_logic_range(_param._shift_2-1, _param._shift_2-1));
+	vhdl->set_alias ("branch_complete_"+toString(i)+"_predictor_0_direction",std_logic(1)," in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY",std_logic_range(_param._shift_2-1, _param._shift_2-1));
 	else
-	vhdl.set_alias ("branch_complete_predictor_0_direction_"+toString(i),std_logic(1)," in_BRANCH_COMPLETE_HISTORY_"+toString(i),std_logic_range(_param._shift_1-1, _param._shift_1-1));
+	vhdl->set_alias ("branch_complete_"+toString(i)+"_predictor_0_direction",std_logic(1)," in_BRANCH_COMPLETE_"+toString(i)+"_HISTORY",std_logic_range(_param._shift_1-1, _param._shift_1-1));
 
       }
       }
-
-
 
     log_printf(FUNC,Meta_Predictor_Glue,"vhdl_declaration","End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl_testbench_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl_testbench_transition.cpp	(revision 43)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Meta_Predictor_Glue/src/Meta_Predictor_Glue_vhdl_testbench_transition.cpp	(revision 44)
@@ -21,84 +21,6 @@
     log_printf(FUNC,Meta_Predictor_Glue,"vhdl_testbench_transition","Begin");
 
-    // Evaluation before read the ouput signal
-    sc_start(0);
-
-    // In order with file Meta_Predictor_Glue_vhdl_testbench_port.cpp
-    // Warning : if a output depend of a subcomponent, take directly the port of subcomponent
-    // (because we have no control on the ordonnancer's policy)
-
-    for (uint32_t i=0; i<_param._nb_prediction; i++)
-      {
-	if (_param._have_meta_predictor)
-	  {
-	_vhdl_testbench->add_input (PORT_READ( in_PREDICT_PREDICTOR_0_ACK [i]));
-	_vhdl_testbench->add_input (PORT_READ( in_PREDICT_PREDICTOR_1_ACK [i]));
-	  }
-	_vhdl_testbench->add_input (PORT_READ( in_PREDICT_PREDICTOR_2_ACK [i]));
-	_vhdl_testbench->add_output(PORT_READ(out_PREDICT_ACK [i]));
-
-	if (_param._have_meta_predictor)
-	  {
-	if (_param._predictor_0_have_bht)
-	_vhdl_testbench->add_input (PORT_READ( in_PREDICT_PREDICTOR_0_BHT_HISTORY [i]));
-	if (_param._predictor_0_have_pht)
-	_vhdl_testbench->add_input (PORT_READ( in_PREDICT_PREDICTOR_0_PHT_HISTORY [i]));
-	if (_param._predictor_1_have_bht)
-	_vhdl_testbench->add_input (PORT_READ( in_PREDICT_PREDICTOR_1_BHT_HISTORY [i]));
-	if (_param._predictor_1_have_pht)
-	_vhdl_testbench->add_input (PORT_READ( in_PREDICT_PREDICTOR_1_PHT_HISTORY [i]));
-	  }
-	if (_param._predictor_2_have_bht)
-	_vhdl_testbench->add_input (PORT_READ( in_PREDICT_PREDICTOR_2_BHT_HISTORY [i]));
-	if (_param._predictor_2_have_pht)
-	_vhdl_testbench->add_input (PORT_READ( in_PREDICT_PREDICTOR_2_PHT_HISTORY [i]));
-
-	_vhdl_testbench->add_output(PORT_READ(out_PREDICT_HISTORY [i]));
-	_vhdl_testbench->add_output(PORT_READ(out_PREDICT_DIRECTION [i]));
-      }
-
-    for (uint32_t i=0; i<_param._nb_branch_complete; i++)
-      {
-	if (_param._have_meta_predictor)
-	  {
-	_vhdl_testbench->add_input (PORT_READ( in_BRANCH_COMPLETE_VAL             [i]));
-	_vhdl_testbench->add_output(PORT_READ(out_BRANCH_COMPLETE_PREDICTOR_2_VAL [i]));
-
-	_vhdl_testbench->add_input (PORT_READ( in_BRANCH_COMPLETE_PREDICTOR_0_ACK [i]));
-	_vhdl_testbench->add_input (PORT_READ( in_BRANCH_COMPLETE_PREDICTOR_1_ACK [i]));
-	  }
-	_vhdl_testbench->add_input (PORT_READ( in_BRANCH_COMPLETE_PREDICTOR_2_ACK [i]));
-	_vhdl_testbench->add_output(PORT_READ(out_BRANCH_COMPLETE_ACK [i]));
-
-	if (_param._have_meta_predictor)
-	  {
-	if (_param._predictor_0_have_bht)
-	_vhdl_testbench->add_output(PORT_READ(out_BRANCH_COMPLETE_PREDICTOR_0_BHT_HISTORY [i]));
-	if (_param._predictor_0_have_pht)
-	_vhdl_testbench->add_output(PORT_READ(out_BRANCH_COMPLETE_PREDICTOR_0_PHT_HISTORY [i]));
-	if (_param._predictor_1_have_bht)
-	_vhdl_testbench->add_output(PORT_READ(out_BRANCH_COMPLETE_PREDICTOR_1_BHT_HISTORY [i]));
-	if (_param._predictor_1_have_pht)
-	_vhdl_testbench->add_output(PORT_READ(out_BRANCH_COMPLETE_PREDICTOR_1_PHT_HISTORY [i]));
-	  }
-	if (_param._predictor_2_have_bht)
-	_vhdl_testbench->add_output(PORT_READ(out_BRANCH_COMPLETE_PREDICTOR_2_BHT_HISTORY [i]));
-	if (_param._predictor_2_have_pht)
-	_vhdl_testbench->add_output(PORT_READ(out_BRANCH_COMPLETE_PREDICTOR_2_PHT_HISTORY [i]));
-
-	_vhdl_testbench->add_input (PORT_READ( in_BRANCH_COMPLETE_HISTORY   [i]));
-	if (_param._have_meta_predictor)
-	  {
-	_vhdl_testbench->add_input (PORT_READ( in_BRANCH_COMPLETE_DIRECTION [i]));
-	_vhdl_testbench->add_output(PORT_READ(out_BRANCH_COMPLETE_PREDICTOR_2_DIRECTION [i]));
-	  }
-      }
-    
-    // add_test :
-    //  - True  : the cycle must be compare with the output of systemC
-    //  - False : no test
-    _vhdl_testbench->add_test(true);
-
-    _vhdl_testbench->new_cycle (); // always at the end
+//  sc_start(0);
+    _interfaces->testbench();
 
     log_printf(FUNC,Meta_Predictor_Glue,"vhdl_testbench_transition","End");
